var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { JOB_STATUS } from "../constants";
export default {
    run(input, execution) {
        return __awaiter(this, void 0, void 0, function* () {
            const { collection, multiple = false, params = {} } = this.config;
            const repo = this.constructor.database.getRepository(collection);
            const options = execution.getParsedValue(params);
            const result = yield repo.update(Object.assign(Object.assign({}, options), { transaction: execution.transaction }));
            return {
                result: multiple ? result : (result[0] || null),
                status: JOB_STATUS.RESOLVED
            };
        });
    }
};
//# sourceMappingURL=update.js.map