"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../constants");
const calculators_1 = require("../calculators");
// @calculation: {
//   calculator: 'concat',
//   operands: [
//     {
//       type: 'calculation',
//       options: {
//         calculator: 'add',
//         operands: [{ value: 1 }, { value: 2 }]
//       }
//     },
//     {
//       type: 'constant',
//       value: '{{$context.data.title}}'
//     },
//     {
//       type: 'context',
//       options: {
//         path: 'data.title'
//       }
//     },
//     {
//       type: 'constant',
//       value: 1
//     }
//   ]
// }
exports.default = {
    run(prevJob, execution) {
        return __awaiter(this, void 0, void 0, function* () {
            const { calculation } = this.config || {};
            const result = calculation
                ? (0, calculators_1.calculate)({
                    type: '$calculation',
                    options: execution.getParsedValue(calculation)
                }, prevJob, execution)
                : null;
            return {
                result,
                status: constants_1.JOB_STATUS.RESOLVED
            };
        });
    }
};
//# sourceMappingURL=calculation.js.map