import { Database, Model } from '@nocobase/database';
import { HasManyCountAssociationsMixin, HasManyCreateAssociationMixin, HasManyGetAssociationsMixin } from 'sequelize';
import ExecutionModel from './Execution';
import FlowNodeModel from './FlowNode';
export default class WorkflowModel extends Model {
    static database: Database;
    id: number;
    title: string;
    enabled: boolean;
    description?: string;
    type: string;
    config: any;
    useTransaction: boolean;
    createdAt: Date;
    updatedAt: Date;
    nodes: FlowNodeModel[];
    getNodes: HasManyGetAssociationsMixin<FlowNodeModel>;
    createNode: HasManyCreateAssociationMixin<FlowNodeModel>;
    executions: ExecutionModel[];
    countExecutions: HasManyCountAssociationsMixin;
    getExecutions: HasManyGetAssociationsMixin<ExecutionModel>;
    createExecution: HasManyCreateAssociationMixin<ExecutionModel>;
    static mount(): Promise<void>;
    getHookId(): string;
    getTransaction(options: any): any;
    toggle(enable?: boolean): Promise<void>;
    trigger(context: Object, options: any): Promise<ExecutionModel>;
}
