"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const server_1 = require("@nocobase/server");
const Workflow_1 = __importDefault(require("./models/Workflow"));
const Execution_1 = __importDefault(require("./models/Execution"));
const actions_1 = __importDefault(require("./actions"));
class WorkflowPlugin extends server_1.Plugin {
    load(options = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            const { db } = this.app;
            db.registerModels({
                WorkflowModel: Workflow_1.default,
                ExecutionModel: Execution_1.default,
            });
            yield db.import({
                directory: path_1.default.resolve(__dirname, 'collections'),
            });
            (0, actions_1.default)(this.app);
            // [Life Cycle]:
            //   * load all workflows in db
            //   * add all hooks for enabled workflows
            //   * add hooks for create/update[enabled]/delete workflow to add/remove specific hooks
            this.app.on('beforeStart', () => __awaiter(this, void 0, void 0, function* () {
                const { model } = db.getCollection('workflows');
                yield model.mount();
            }));
            // [Life Cycle]: initialize all necessary seed data
            this.app.on('db.init', () => __awaiter(this, void 0, void 0, function* () { }));
            // const [Automation, AutomationJob] = database.getModels(['automations', 'automations_jobs']);
            // Automation.addHook('afterCreate', async (model: AutomationModel) => {
            //   model.get('enabled') && await model.loadJobs();
            // });
            // Automation.addHook('afterUpdate', async (model: AutomationModel) => {
            //   if (!model.changed('enabled' as any)) {
            //     return;
            //   }
            //   model.get('enabled') ? await model.loadJobs() : await model.cancelJobs();
            // });
            // Automation.addHook('beforeDestroy', async (model: AutomationModel) => {
            //   await model.cancelJobs();
            // });
            // AutomationJob.addHook('afterCreate', async (model: AutomationJobModel) => {
            //   await model.bootstrap();
            // });
            // AutomationJob.addHook('beforeDestroy', async (model: AutomationJobModel) => {
            //   await model.cancel();
            // });
        });
    }
    getName() {
        return this.getPackageName(__dirname);
    }
}
exports.default = WorkflowPlugin;
//# sourceMappingURL=server.js.map